#include "textlcd.h"

extern void delay(unsigned long ms);

void LCD_WriteFn8Bit(void) {
	unsigned char cmd =  0x30; // 0b00110000
	LCD_PORT = cmd;
	cmd |= (1 << LCD_BIT_E);
	LCD_PORT = cmd;
	cmd &= ~(1 << LCD_BIT_E);
	LCD_PORT = cmd;
	delay(5);
}

void LCD_WriteFn4Bit(void) {
	unsigned char cmd = 0x20; // 0b00100000
	LCD_PORT = cmd;
	cmd |= (1 << LCD_BIT_E);
	LCD_PORT = cmd;
	cmd &= ~(1 << LCD_BIT_E);
	LCD_PORT = cmd;
	delay(5);
}

void LCD_Init(void) {
	delay(40);
	LCD_WriteFn8Bit();
	LCD_WriteFn8Bit();
	LCD_WriteFn8Bit();
	LCD_WriteFn4Bit();
	delay(40);
	LCD_Inst(0x28); // 0b00101000
	LCD_Inst(0x0C); // 0b00001100
	LCD_Inst(0x01); // 0b00000001
	LCD_Inst(0x06); // 0b00000110
}

void LCD_SetCursor(unsigned char pos) {
	LCD_Inst(pos | LCD_POS);
}

void LCD_Inst(unsigned char cmd) {
	unsigned char temp = cmd & 0xF0;
	LCD_PORT = temp;
	temp |= (1 << LCD_BIT_E);
	LCD_PORT = temp;
	temp &= ~(1 << LCD_BIT_E);
	LCD_PORT = temp;
	
	temp = (cmd << 4) & 0xF0;
	LCD_PORT = temp;
	temp |= (1 << LCD_BIT_E);
	LCD_PORT = temp;
	temp &= ~(1 << LCD_BIT_E);
	LCD_PORT = temp;
	
	delay(2);
}

void LCD_Data(unsigned char data) {
	unsigned char temp = data & 0xF0;
	temp |= (1 << LCD_BIT_RS);
	LCD_PORT = temp;
	temp |= (1 << LCD_BIT_E);
	LCD_PORT = temp;
	temp &= ~(1 << LCD_BIT_E);
	LCD_PORT = temp;
	temp &= ~(1 << LCD_BIT_RS);
	LCD_PORT = temp;
		
	temp = (data << 4) & 0xF0;
	temp |= (1 << LCD_BIT_RS);
	LCD_PORT = temp;
	temp |= (1 << LCD_BIT_E);
	LCD_PORT = temp;
	temp &= ~(1 << LCD_BIT_E);
	LCD_PORT = temp;
	temp &= ~(1 << LCD_BIT_RS);
	LCD_PORT = temp;
	
	delay(1);
}