#ifndef __TEXTLCD_H__
#define __TEXTLCD_H__

#include "monitor.h"

#define LCD_PORT	PIO_A_DATA
#define LCD_BIT_RS	2
#define LCD_BIT_E	3
#define LCD_WIDTH	16
#define LCD_LINE1	0x00
#define LCD_LINE2	0x40
#define LCD_CLEAR	0x01 // 0b00000001
#define LCD_OFF		0x08 // 0b00001000
#define LCD_ON		0x0C // 0b00001100 On, no cursor, no blink
#define LCD_UNDER	0x0E // 0b00001110 On, cursor = underscore
#define LCD_BLINK	0x0D // 0b00001101 On, cursor = blink block
#define LCD_BOTH	0x0F // 0b00001111 On, cursor = blink block + underscore
#define LCD_POS		0x80 // 0b10000000 Position cursor
#define LCD_DEF		0x40 // 0b01000000 Define character

void LCD_Init(void);
void LCD_SetCursor(unsigned char pos);
void LCD_Data(unsigned char data);
void LCD_Inst(unsigned char cmd);

#endif